#### Nacitanie suboru s genovou expresiou
load("GSE20194_MDACC_Expression.rdata")
ls()

### Kontrola spravnosti nacitania a vlastnosti suboru
is(X) # co je to za objekt
dim(X) # dimenzia tabulky
X[1:5,1:5] # nahlad prvych 5 riadkov a stlpcov...subor ma v riadkoch vzorky a v stlpcoch geny

#Nacitanie klinickej informacie k vzorkam
clinical = read.csv("GSE20194_MDACC_Sample_Info.csv", header=TRUE)

#Skontrolovanie nacitania
head(clinical)
dim(clinical)

################## ZAKLADNA KONTROLA KVALITY DAT A ZAKLADNE STATISTIKY ###################

### Kontrola klinickych dat ###
# ake mame premenne v subore #
names(clinical)

# ake su hodnoty tychto premennych #
str(clinical)

# Factor - je faktor, kategoricka premenna, nominalna
# int - spojita premenna, integer
# logi - logicka premenna (TRUE, FALSE)
# Identifikujte vyznam premennych ktore nepoznate
# Kontrola veku
# nakreslime histogram
hist(clinical$Age)

#nakreslime boxplot
boxplot(clinical$Age)

#vypocitame statistiky
quantile(clinical$Age)

# mame tam chybajuce hodnoty, musime zadat vo funkcii aby boli odstranene z vypoctu
quantile(clinical$Age, na.rm=TRUE)

# Prebehla kontrola veku v poriadku?

## Kontrola kategorialnej premennej rasa ##
# nakreslime barplot
plot(clinical$Race)
# ktorej rasy je v subore najviac?

# ake su pocty jednotlivych ras v subore?
table(clinical$Race)

# ake je percentualne zastupenie jednotlivych ras?
a=table(clinical$Race) # ulozime si tabulku do premennej a

#premenime na percenta a zaokruhlime na 1 desatinne miesto
b=a/sum(a) #
is(b) #zistime, co je to vlastne b
#je to tabulka
b
# s tabulkou spojitych hodnot mozeme pracovat ako s cislami, takze vynasobime 100 aby sme premenili na percenta
b*100
round(b*100, 1) # zaokruhlime na 1 desatinne miesto
d = round(b*100, 1) # zaokruhlime na 1 desatinne miesto
d

## kontrola kategorickej a spojitej premennej ## 
# skontrolujeme ci kategoricka premenna ER status spravne deli spojitu premennu z imunohistochemie 
boxplot(clinical$ER~clinical$ER_status)

#aka je hranica pre oznacenie ER pozitivny?
tapply(clinical$ER, clinical$ER_status, FUN=function(x) quantile(x, na.rm=TRUE))

#### Kontrola genovych expresnych dat ####
quantile(X) 
# data su v poriadku, mali by byt v rozmedzi 0-15

################ Analyza dat ##################
## 1) V analyze budeme musiet spojit genove expresne data s klinickymi. Jedna sa o dve tabulky, ale nie je potrebne ich spajat do jednej, len treba vediet ako sa na ne spravne odvolavat. 
# 1a) Musime zistit indentifikatorovy stlpec v klinickych datach, ktory nam prepaja klinicke data s genovymi expresnymi

rownames(X)[1:2] # toto su nazvy vzoriek v genovej expresii
head(clinical)

# Stlpec v datach clinical najblizsi nazvom riadkov v genovej expresnej matici je treti s nazvom CEL.file
# Stale to ale nie je presne to iste, lebo nazvy v genovej expresnej matici maju predponu GSM... a priponu .gz
# Odstranime predponu a priponu nazvov riadkov matice X, novo vyvtoreny vektor ulozime do premennej v

v = sapply(rownames(X),FUN=function(x) substring(x, 11, nchar(x)-3))

# Porovname novy vektor s tretim stlpcom klinickeho suboru. Ak nazvy sedia, su subory zoradene rovnako a mozeme ich tak ak pouzivat

match(v, clinical$CEL.file)
plot(match(v, clinical$CEL.file))
which(is.na(match(v, clinical$CEL.file)))

# Zda sa, ze 229 a 277 vzorka z genovych expresnych dat nema klinicke data?
clinical[c(229,277),]
v[c(229,277)]
clinical[c(229,277),3]

# Maju, len sa nazvy trochu lisia
# Zda sa teda, ze riadky genovych expresnych dat i klinickych dat si navzajom zodpovedaju

### 2) Vykreslime si expresiu genu ESR1 ako boxploty v skupine ER+ a ER-
# ER+ a ER- je zakodovana v premennej ...
clinical$ER_status

# expresia genu ESR1 sa skryva v matici X
X[,"ESR1"]

# boxplot teda vykreslime nasledovne
boxplot(X[,"ESR1"]~clinical$ER_status)

# vidime, ze genova expresia genu ESR1 je vyssia v skupine ER+ (kodovana ako P)
# zistime, ci je tento rozdiel statisticky vyznamny
# pouzijeme napriklad t.test
t.test(X[,"ESR1"]~clinical$ER_status)

# rozdiel je statisticky vyznamny. Vsimnime si, ze sme pouzili uplne rovnaky prikaz ako pre boxplot, akurat sme vymenili funkciu

### 3) NAJDIME VSETKY GENY ROZLICNE EXPRIMOVANE MEDZI ER+ a ER-!
# musime testovat gen po gene, ale zautomatizujeme si to, pouzitim funkcie apply
# budeme ukladat len p-hodnoty a hodnoty statistiky. Na to budeme potrebovat vediet, kde ich najdeme

a = t.test(X[,"ESR1"]~clinical$ER_status) # ulozime si vysledok t.testu 
str(a) # zistime strukturu vysledneho objektu

# vidime, ze p-hodnoty su ulozene pod nazvom p.value a statistika pod nazvom statistic
a$p.value
a$statistic

# aplikujme teda pomocou funkcie apply na stlpce matice X t.test
p_hodnoty = apply(X,2,FUN=function(x) t.test(x~clinical$ER_status)$p.value)# ulozime p hodnoty
t_statistiky = apply(X,2,FUN=function(x) t.test(x~clinical$ER_status)$statistic)# ulozime t statistiky

# prezrieme si vysledky
p_hodnoty[1:5]
t_statistiky[1:5]

# zobrazime si histogram p-hodnot
hist(p_hodnoty)

# kvoli problemu mnohonasobneho testovania musime upravit p-hodnoty
adj_p_hodnoty = p.adjust(p_hodnoty, method="BH") # pouzijeme Benjamini-Hochbergovu korekciu FDR

# Teraz si vysledky ulozime pekne do datovej tabulky
ER_vysledky = data.frame(Gen=names(t_statistiky), Tstat=t_statistiky, pval=p_hodnoty, adjpval=adj_p_hodnoty)
head(ER_vysledky)

write.table(ER_vysledky, file="ER_vysledky.txt", row.names=FALSE)
save(ER_vysledky, file="ER_vysledky.rdata")

# Zistime ktore geny su statisticky vyznamne odlisne exprimovane medzi ER+ a ER-?
ER_vyzn=which(ER_vysledky$adjpval<0.05)
ER_vyzn

# ake su ich nazvy?
ER_vysledky[ER_vyzn,1]

# najdime vyznamne geny s vyssou expresiou v ER+
ER_vyzn_UP=which(ER_vysledky$adjpval<0.05 & ER_vysledky$Tstat>0)
ER_vyzn_UP=ER_vysledky[which(ER_vysledky$adjpval<0.05 & ER_vysledky$Tstat>0),1]
ER_vyzn_UP[1:5]

# podobne najdeme aj vyznamne geny s nizsou expresou v ER-
ER_vyzn_DN=ER_vysledky[which(ER_vysledky$adjpval<0.05 & ER_vysledky$Tstat<0),1]
ER_vyzn_DN[1:5]

# najdime prvych 100 najvyznamnejsich genov obecne
# musime ich zoradit podla vyznamnosti (teda vzostupne na zaklad adj. p hodnoty) a potom vyberieme prvych 100
ER_vysl_ord = ER_vysledky[order(ER_vysledky$adjpval), ]

head(ER_vysl_ord)
top100=ER_vysl_ord[1:100,1]
top100
save(top100, file="top100.rdata")
## Najdite geny odlisne exprimovane medzi HER2+ a HER2-. Ulozte ich do podobnej tabulky a vyexportujte si vektor top100 genov 
##(pouzite iny nazov premennej, aby sa Vam neprekryl)



#### Pouzijeme SAM ####
install.packages("samr")
install.packages("C:/Users/user/Downloads/samr_2.0.tar.gz", type="source")
library(samr)

ER.sam = c(clinical$ER_status=="P")+1

data.sam=list(x=t(X),y=ER.sam, logged2=TRUE, geneid=colnames(X), genenames=colnames(X))

# testovanie hypotezy, odhad s0 a spocitanie ocakavanych hodnot d_e
samr.obj<-samr(data=data.sam,  resp.type="Two class unpaired", nperms=1000)


#vykreslime graf SAM (ocakavane vs pozorovane hodnoty statistiky)
samr.plot(samr.obj)

# Prehlad FDR hodnot v zavislosti od rozneho intervalu delta

delta.table <- samr.compute.delta.table(samr.obj)

head(delta.table)

# Vypocitanie tabulky odlisne expr.genov
siggenes.table<-samr.compute.siggenes.table(samr.obj,del=0.4, data=data.sam, delta.table)

str(siggenes.table)

head(siggenes.table$genes.up)
head(siggenes.table$genes.lo)

### Regresne strategie ###

# vyberte geny, ktore su specificke pre ER status
# s prihliadnutim na efekt HER2 statusu
# pouzijeme napr. linearni modely

# pre 1 gen:

de1 = lm(X[,2]~ER_status+HER2.Status, data=clinical)
summary(de1)$coefficients


# pre vsetky geny, vyberieme prvy (odhad exprese) a stvrty stlpec (p hodnota)
de = apply(X, 2, function(z) (
    matrix(summary(lm(z ~ ER_status + HER2.Status, data=clinical))$coefficients[,c(1,4)], ncol=1, byrow=FALSE) )
    )
rownames(de) = c("b0", "ER+", "HER2+", "b0 pval","pvalER", "pvalHER")


# adjustacia p hodnot
de.adj = de
de.adj = rbind(de,adj.p.ER = p.adjust(de[5,], method='BH'), adj.p.HER2=p.adjust(de[6,], method='BH'))

head(de.adj)

de.adj.fin = as.data.frame(t(de.adj))
head(de.adj.fin)

# ER+ specificke geny (nie su vyznamne v HER2):

ERspec = rownames(de.adj.fin)[which(de.adj.fin$adj.p.ER<0.00000001 & de.adj.fin$adj.p.HER2>0.1)]

# geny specificke pro ER+ in HER2+

ER.HER2spec = rownames(de.adj.fin)[which(de.adj.fin$adj.p.ER<0.001 & de.adj.fin$adj.p.HER2<0.001)]

de.adj.fin[ER.HER2spec[1:5],]



# Uloha 1b
# Najdite odlisne exprimovane geny medzi ER+ a ER- pomocou balika limma.
# Navod (kroky analyzy)
# fitujte linerny model
# upravte statistiky pomocou empirickej bayesovskej metdy
# vytvorte tabulku top 10 najvznamnejch gnov po adjustcii Benjanmini-Hochbergom
# vytvorte tabulku pre vetky gny
# nakreslite histogram adjustovanych p-hodnot
# nakreslite volcano plot















